unit DB2Demo1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB2Qry, ExtCtrls, Buttons, Grids,
  TGQry, DataCtrl, Menus, DataImg;

type
  TForm1 = class(TForm)
    Connection: TDB2Con;
    DemoQuery: TDB2Query;
    CreateTable: TDB2Query;
    InsertValues: TDB2Query;
    DataMemo1: TDataMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Label4: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    LoadText1: TMenuItem;
    LoadBMP1: TMenuItem;
    N1: TMenuItem;
    SaveText1: TMenuItem;
    SaveBMP1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Demo1: TMenuItem;
    CreateTable1: TMenuItem;
    N3: TMenuItem;
    OpenQuery1: TMenuItem;
    CloseQuery1: TMenuItem;
    View1: TMenuItem;
    Sort1: TMenuItem;
    Filter1: TMenuItem;
    N4: TMenuItem;
    DeletedRecords: TMenuItem;
    OriginalRecords: TMenuItem;
    DataRecords: TMenuItem;
    N5: TMenuItem;
    SaveData1: TMenuItem;
    Panel4: TPanel;
    First: TSpeedButton;
    DeleteRecord: TSpeedButton;
    Prior: TSpeedButton;
    InsertRecord: TSpeedButton;
    Next: TSpeedButton;
    GotoRecord: TSpeedButton;
    Last: TSpeedButton;
    SaveData: TSpeedButton;
    Button1: TButton;
    Label5: TLabel;
    Edit4: TEdit;
    DataGrid1: TDataGrid;
    DataImage1: TDataImage;
    DropTable: TDB2Query;
    DropTable1: TMenuItem;
    StatusLabel: TLabel;
    Record1: TMenuItem;
    RestoreUndo1: TMenuItem;
    Undelete1: TMenuItem;
    Find1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure FirstClick(Sender: TObject);
    procedure PriorClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure LastClick(Sender: TObject);
    procedure DeleteRecordClick(Sender: TObject);
    procedure InsertRecordClick(Sender: TObject);
    procedure SaveDataClick(Sender: TObject);
    procedure GotoRecordClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LoadText1Click(Sender: TObject);
    procedure LoadBMP1Click(Sender: TObject);
    procedure SaveBMP1Click(Sender: TObject);
    procedure SaveText1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure OpenQuery1Click(Sender: TObject);
    procedure CloseQuery1Click(Sender: TObject);
    procedure Filter1Click(Sender: TObject);
    procedure DeletedRecordsClick(Sender: TObject);
    procedure OriginalRecordsClick(Sender: TObject);
    procedure DataRecordsClick(Sender: TObject);
    procedure DropTable1Click(Sender: TObject);
    procedure RowStatus(Sender: TComponent);
    procedure DemoQueryAfterScroll(Sender: TComponent;
      ScrollBy: TScrollType; ScrollInfo: Longint);
    procedure Sort1Click(Sender: TObject);
    procedure RestoreUndo1Click(Sender: TObject);
    procedure Undelete1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
  private
    { Private declarations }
    Edited: Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses DB2API, DB2Demo2, DB2Demo3;
{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  RowNo: LongInt;
  MyDate: Date_Struct;
begin
  Connection.AutoCommit := False;
  try
    CreateTable.Execute;

    MyDate.Year := 1995;
    MyDate.Month := 7;

    with InsertValues do
    begin
      Prepared := True;
      for RowNo := 1 to 100 do
      begin
        Params[1].AsInteger := RowNo;
        Params[2].AsString := 'Row' + IntToStr(RowNo);
        MyDate.Day := RowNo mod 30 + 1;
        Params[3].AsDate := MyDate;
        Execute;
      end;
      Prepared := False;
    end;
    Connection.ICommit(InsertValues.ConnectionNo);
    Connection.IConnected[InsertValues.ConnectionNo] := False;
  finally
    Connection.AutoCommit := True;
  end;
  MessageDlg('Demo table and data successfully created', mtInformation, [mbOk], 0);
end;

procedure TForm1.FirstClick(Sender: TObject);
begin
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.First;
end;

procedure TForm1.PriorClick(Sender: TObject);
begin
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Prior;
end;

procedure TForm1.NextClick(Sender: TObject);
begin
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Next;
end;

procedure TForm1.LastClick(Sender: TObject);
begin
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Last;
end;

procedure TForm1.DeleteRecordClick(Sender: TObject);
begin
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Delete;
end;

procedure TForm1.InsertRecordClick(Sender: TObject);
begin
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Insert;
end;

procedure TForm1.SaveDataClick(Sender: TObject);
begin
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.Update;
  DemoQuery.ResetRows;
end;

procedure TForm1.GotoRecordClick(Sender: TObject);
begin
  if not DemoQuery.Active then DemoQuery.Active := True;
  DemoQuery.RecordNo := StrToInt(Edit4.Text);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenDialog1.InitialDir := ExtractFilePath(ParamStr(0));
  SaveDialog1.InitialDir := ExtractFilePath(ParamStr(0));
end;

procedure TForm1.LoadText1Click(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    DefaultExt := 'txt';
    if Execute then
      (DemoQuery.FieldByName('Notes') as TGTextField).LoadFromFile(FileName);
  end;
end;

procedure TForm1.LoadBMP1Click(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    DefaultExt := 'bmp';
    if Execute then
      (DemoQuery.FieldByName('Picture') as TGBinaryField).LoadFromFile(FileName);
  end;
end;

procedure TForm1.SaveBMP1Click(Sender: TObject);
begin
  with SaveDialog1 do
  begin
    DefaultExt := 'bmp';
    if Execute then
      (DemoQuery.FieldByName('Picture') as TGBinaryField).SaveToFile(FileName);
  end;
end;

procedure TForm1.SaveText1Click(Sender: TObject);
begin
  with SaveDialog1 do
  begin
    DefaultExt := 'txt';
    if Execute then
      (DemoQuery.FieldByName('Notes') as TGTextField).SaveToFile(FileName);
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.OpenQuery1Click(Sender: TObject);
begin
  DemoQuery.Active := True;
end;

procedure TForm1.CloseQuery1Click(Sender: TObject);
begin
  DemoQuery.Active := False;
end;

procedure TForm1.Filter1Click(Sender: TObject);
begin
  MessageDlg('Feature Not Implemented Yet', mtInformation, [mbOk], 0);
end;

procedure TForm1.DeletedRecordsClick(Sender: TObject);
begin
  DeletedRecords.Checked := True;
  OriginalRecords.Checked := False;
  DataRecords.Checked := False;

  DemoQuery.Buffer := bDeleted;
end;

procedure TForm1.OriginalRecordsClick(Sender: TObject);
begin
  DeletedRecords.Checked := False;
  OriginalRecords.Checked := True;
  DataRecords.Checked := False;

  DemoQuery.Buffer := bOriginal;
end;

procedure TForm1.DataRecordsClick(Sender: TObject);
begin
  DeletedRecords.Checked := False;
  OriginalRecords.Checked := False;
  DataRecords.Checked := True;

  DemoQuery.Buffer := bData;
end;

procedure TForm1.DropTable1Click(Sender: TObject);
begin
  DemoQuery.Active := False;
  DropTable.Execute;
end;

procedure TForm1.RowStatus(Sender: TComponent);
begin
  Case DemoQuery.RowStatus of
    rsOriginal: StatusLabel.Caption := ' Unmodified';
    rsModified: StatusLabel.Caption := ' Modified';
    rsNew: StatusLabel.Caption := ' New Unmodified';
    rsNewModified: StatusLabel.Caption := ' New Modified';
    rsDeleted: StatusLabel.Caption := ' Deleted';
  end;
end;

procedure TForm1.DemoQueryAfterScroll(Sender: TComponent;
  ScrollBy: TScrollType; ScrollInfo: Longint);
begin
  Case DemoQuery.RowStatus of
    rsOriginal: StatusLabel.Caption := ' Unmodified';
    rsModified: StatusLabel.Caption := ' Modified';
    rsNew: StatusLabel.Caption := ' New Unmodified';
    rsNewModified: StatusLabel.Caption := ' New Modified';
    rsDeleted: StatusLabel.Caption := ' Deleted';
  end;
end;

procedure TForm1.Sort1Click(Sender: TObject);
var
  Order: String;
begin
  Order := '';

  with Form2 do
  begin
    if ShowModal = mrOk then
    begin
      if Descending.Checked then Order := ' Des';
      if ListBox1.ItemIndex < 0 then
        raise Exception.Create('Must select a field');
      Order := ListBox1.Items[ListBox1.ItemIndex] + Order;
      DemoQuery.Sort(Order);
    end;
  end;
end;

procedure TForm1.RestoreUndo1Click(Sender: TObject);
begin
  DemoQuery.Undo;
end;

procedure TForm1.Undelete1Click(Sender: TObject);
begin
  DemoQuery.Undelete;
end;

procedure TForm1.Find1Click(Sender: TObject);
begin
  with Form3 do
  begin
    if ShowModal = mrOk then
      DemoQuery.Find([SearchValue.Text]);
  end;
end;

end.
